/* image.hh: skin image holder header.
 *
 * Copyright (c) 2006 Jonne Lehtinen <jms@modeemi.fi>
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the Do What The F*ck You Want To
 *  Public License, Version 2, as published by Sam Hocevar. See
 *  COPYING file for more details.
 */

#ifndef GX2OSD_IMAGE_HH
#define GX2OSD_IMAGE_HH

#include <gdkmm/pixbuf.h>
#include "boost/noncopyable.hpp"

namespace gx2osd {

    struct position {
        unsigned int x;
        unsigned int y;
    };

    class image : private boost::noncopyable {

        public:
            image();
            ~image();

            operator Glib::RefPtr< Gdk::Pixbuf >();
            const image& operator=( const Glib::RefPtr< Gdk::Pixbuf >& rvalue );

            void set_position( unsigned int x, unsigned int y );
            const position& get_position() const;

        private:

            Glib::RefPtr< Gdk::Pixbuf > image_;

            position position_;

    };

}

#endif // GX2OSD_IMAGE_HH
