#ifndef ECLI_X11_SHORTCUT_IMPL_HH
#define ECLI_X11_SHORTCUT_IMPL_HH

#include "key_combination.hh"
#include <boost/function.hpp>

namespace ecli
{

namespace detail
{

struct impl_data;

class shortcut_impl
{
    public:
        shortcut_impl();
        ~shortcut_impl();

        bool
        register_shortcut( ecli::key_combination const& key,
                           boost::function< void() > const& callback );

        void
        unregister_shortcut( ecli::key_combination const& key );

    private:
        impl_data* data;

};

} // namespace detail

} // namespace ecli

#endif // ECLI_X11_SHORTCUT_IMPL_HH
