#ifndef ECLI_GLOBAL_SHORTCUT_HH
#define ECLI_GLOBAL_SHORTCUT_HH

#include <boost/function.hpp>
#include "key_combination.hh"
#include "detail/shortcut_impl.hh"

namespace ecli
{


class global_shortcuts
{
    public:

        global_shortcuts();
        ~global_shortcuts();

        bool
        register_shortcut( ecli::key_combination const& key_comb,
                           boost::function< void() > const& callback );

        void
        unregister_shortcut( ecli::key_combination const& key_comb );

    private:

        ecli::detail::shortcut_impl impl_;

};

} // namespace ecli

#endif // ECLI_GLOBAL_SHORTCUT_HH
