#ifndef ECLI_KEY_COMBINATION_HH
#define ECLI_KEY_COMBINATION_HH

#include <string>
#include <glib/gtypes.h>

namespace ecli
{

class key_combination
{
    public:
        key_combination( std::string const& combination );
        ~key_combination();

        guint
        get_modifiers() const;

        guint
        get_key() const;

    private:
        void
        parse_combination( std::string const& combination );

        guint modifiers_;
        guint key_;

        struct conversion_table
        {
            std::string name;
            guint value;
        };
        static conversion_table conversion_table_[];

};

} // namespace ecli

#endif // ECLI_KEY_COMBINATION_HH
