#include "statusicon.hh"
#include "window_holder.hh"
#include "config.hh"
#include <iostream>
#include <gtkmm/window.h>
#include <gtkmm/menuitem.h>
#include <gtkmm/label.h>
#include <boost/foreach.hpp>
#include <map>

gx2osd::status_icon::status_icon()
    : status_icon_( Gtk::StatusIcon::create( "xmms2" ) ),
      popup_menu_(), menu_items_()
{
    typedef std::pair< char const*, sigc::slot< void > > menu_item_t;
    menu_item_t menu_items[] = 
        { std::make_pair("<b>Show</b>", 
                         sigc::mem_fun(get_window_holder(),
                                       &gx2osd::window_holder::show_all)),
          std::make_pair("Config",
                         sigc::mem_fun(*this, &gx2osd::status_icon::config)) };
    BOOST_FOREACH( menu_item_t item, menu_items )
    {
        Gtk::MenuItem* temp( new Gtk::MenuItem(item.first) );
        menu_items_.push_back( temp );
        popup_menu_.append( *temp );
        temp->signal_activate().connect( item.second );
        dynamic_cast< Gtk::Label* >( temp->get_child() )->set_use_markup();
    }
    popup_menu_.show_all();
    status_icon_->signal_activate().connect( menu_items[0].second );
    status_icon_->signal_popup_menu().connect(
        sigc::mem_fun(*this, &gx2osd::status_icon::popup) );
}

gx2osd::status_icon::~status_icon()
{
}

void
gx2osd::status_icon::popup( guint button, guint32 activate_time )
{
    status_icon_->popup_menu_at_position( popup_menu_, button, activate_time );
}

void
gx2osd::status_icon::config()
{
    gx2osd::get_config().get_conf_window().show();
}
